BICO 1.1

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Pages
Public Types | Public Member Functions | Private Attributes | List of all members
CluE::Bico< T >::BicoNode Class Reference

Class representing a node in BICO's tree. More...

Collaboration diagram for CluE::Bico< T >::BicoNode:

## Public Types
typedef std::pair< CFREntry< T > , BicoNode * > | FeaturePair
typedef std::list< FeaturePair > | FeatureList

## Public Member Functions
| BicoNode (Bico< T > &outer)
void | clear ()
| Delete all nodes. More...
FeatureList::iterator | insert (CFREntry< T > const &feature)
FeatureList::iterator | begin ()
FeatureList::iterator | end ()
size_t | size ()
bool | empty ()
FeatureList::iterator | nearest (T const &element, int level)
void | erase (typename FeatureList::iterator pos)
void | spliceAllTo (BicoNode *to, typename FeatureList::iterator pos)
void | spliceElementTo (typename FeatureList::iterator it, BicoNode *to, typename FeatureList::iterator pos)
int | id ()

## Private Attributes
int | objectId
| Unique object id. More...
Bico< T > & | outer
| Parent BICO instance. More...
FeatureList | features

## Detailed Description

### template<typename T>
class CluE::Bico< T >::BicoNode

Class representing a node in BICO's tree.

Definition at line 50 of file bico.h.

## Member Typedef Documentation

template<typename T>

typedef std::pair<CFREntry<T>, BicoNode*> CluE::Bico< T >::BicoNode::FeaturePair

Definition at line 53 of file bico.h.

template<typename T>

typedef std::list<FeaturePair> CluE::Bico< T >::BicoNode::FeatureList

Definition at line 54 of file bico.h.

## Constructor & Destructor Documentation

template<typename T>

CluE::Bico< T >::BicoNode::BicoNode | ( | Bico< T > & | outer | ) |
| inline

Constructs a node for BICO's tree

Parameters

  outer | Parent BICO instance

Definition at line 60 of file bico.h.

## Member Function Documentation

template<typename T>

void CluE::Bico< T >::BicoNode::clear | ( |  | ) |
| inline

Delete all nodes.

Definition at line 71 of file bico.h.

template<typename T>

FeatureList::iterator CluE::Bico< T >::BicoNode::insert | ( | CFREntry< T > const & | feature | ) |
| inline

Inserts a CFREntry into this node

Parameters

  feature | CFREntry to be inserted

Returns
  Iterator pointing to inserted CFREntry

Definition at line 82 of file bico.h.

template<typename T>

FeatureList::iterator CluE::Bico< T >::BicoNode::begin | ( |  | ) |
| inline

Iterator pointing at the first CFREntry

Returns
  Begin iterator

Definition at line 92 of file bico.h.

template<typename T>

FeatureList::iterator CluE::Bico< T >::BicoNode::end | ( |  | ) |
| inline

Iterator pointing behind the last CFREntry

Returns
  End iterator

Definition at line 101 of file bico.h.

template<typename T>

size_t CluE::Bico< T >::BicoNode::size | ( |  | ) |
| inline

Number of contained CFREntries

Returns
  Number of elements

Definition at line 110 of file bico.h.

template<typename T>

bool CluE::Bico< T >::BicoNode::empty | ( |  | ) |
| inline

Indicates if node is empty

Returns
  Indicator

Definition at line 119 of file bico.h.

template<typename T>

FeatureList::iterator CluE::Bico< T >::BicoNode::nearest | ( | T const & | element,
|  | int | level
| ) |  |
| inline

Returns an iterator to the CFREntry in this node whose reference point is nearest to a fixed point

Parameters

  element | Fixed point
  level | Level of this node

Returns
  Nearest CFREntry

Definition at line 131 of file bico.h.

template<typename T>

void CluE::Bico< T >::BicoNode::erase | ( | typename FeatureList::iterator | pos | ) |
| inline

Removes a specified CFREntry

Parameters

  pos | Position of the CFREntry to be removed

Definition at line 230 of file bico.h.

template<typename T>

void CluE::Bico< T >::BicoNode::spliceAllTo | ( | BicoNode * | to,
|  | typename FeatureList::iterator | pos
| ) |  |
| inline

Inserts all CFREntries of this node into a given FeatureList

Parameters

  to | Destination of insertion
  pos | Position of insertion

Definition at line 240 of file bico.h.

template<typename T>

void CluE::Bico< T >::BicoNode::spliceElementTo | ( | typename FeatureList::iterator | it,
|  | BicoNode * | to,
|  | typename FeatureList::iterator | pos
| ) |  |
| inline

Inserts one CFREntry of this node into a given FeatureList

Parameters

  it | CFREntry to be inserted
  to | Destination of insertion
  pos | Postion of insertion

Definition at line 251 of file bico.h.

template<typename T>

int CluE::Bico< T >::BicoNode::id | ( |  | ) |
| inline

Returns the unique object id

Returns
  Object id

Definition at line 260 of file bico.h.

## Member Data Documentation

template<typename T>

int CluE::Bico< T >::BicoNode::objectId
| private

Unique object id.

Definition at line 269 of file bico.h.

template<typename T>

Bico<T>& CluE::Bico< T >::BicoNode::outer
| private

Parent BICO instance.

Definition at line 274 of file bico.h.

template<typename T>

FeatureList CluE::Bico< T >::BicoNode::features
| private

List of all contained CFREntries

Definition at line 279 of file bico.h.

The documentation for this class was generated from the following file:

- src/clustering/bico.h